<?php
/**
 * FeedGeorge admin class
 * 
 * @package FeedGeorge_Wordpress_PLUGIN
 * @author CH Foo
 * @copyright 2011 FeedGeorge.com
 * @access public
 */

class WP_FG_Admin {
    
    
    function WP_FG_Admin() {
   
        add_action( 'init', array( &$this, 'init' ) );
       
		
    }
	
	function init() {
	
		add_action('admin_menu', array(&$this,'admin_menus'));
		add_action('publish_post', array($this, 'save_geodata'));
		add_action('delete_post', array($this, 'delpost'));
	}
    
    function admin_menus() {
        add_options_page('FeedGeorge Options', 'FeedGeorge', 8, __FILE__, array(&$this, 'option_config_page'));
		
		add_meta_box('fg_location', __('Location', 'fgmap'), array(&$this, 'fgmap_custom_box'), 'post', 'normal','high');
    }
	
	
    
    function admin_head() {
	    global $fg_geo;
        $option = $fg_geo->get_options();
		
        echo '<link rel="stylesheet" href="' . FG_CSS_URL . '/fg_style_admin.css" />';
        echo '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>'."\n";
        echo '<script type="text/javascript" src="'.FG_JS_URL . '/fg_admin.js"></script>';
        echo '<script type="text/javascript" src="'.FG_JS_URL . '/jscolor.js"></script>';
		
		if ($option['isPoly']==1 ) {
			echo '<script type="text/javascript" src="'.FG_JS_URL . '/polytool.js"></script>'; 
		}
		
		
    }
    
    function showScript() {
        
        wp_enqueue_style('fgeorge_css', FG_CSS_URL.'/fg_style_admin.css');
        wp_enqueue_script('GoogleMaps','http://maps.google.com/maps/api/js?sensor=false');
        wp_enqueue_script('fg_admin_script', FG_JS_URL . '/jscolor.js');
    }
    
    


    function option_config_page() {
        if (!current_user_can( 'manage_options' ))  {
            wp_die( __('You do not have sufficient permissions to manage options for this site.') );
        }
        
        if ( isset($_POST['act']) && $_POST['act'] == 'update' ) {
            
			$this->update_config();
        }
        
        $this->show_config_form();
    }
    
	function save_geodata($post_id) {
		global $fg_geo, $fg_ajax;
		$post = get_post($post_id);
		if ( !current_user_can('edit_page', $post_id) ) return $post_id;
				
		if ( isset( $_POST['location_noncename'] ) && !wp_verify_nonce( $_POST['location_noncename'], plugin_basename( __FILE__ ) ) ) {
			return $post_id;
		}
		
		$fg_option = $fg_geo->get_options();
		if ( isset($_POST['geo_latitude']) && isset($_POST['geo_longitude']) ) {
			
			
			delete_post_meta($post_id, FGEORGE_GEOLOCATION);
            
            if (isset($_POST['geo_mapzoom']) && preg_match('/^[0-9]+$/',$_POST['geo_mapzoom'])) {
                $zoom = $_POST['geo_mapzoom'];
            }
            
            if (isset($_POST['geo_maptype']) && preg_match('/^[a-zA-Z]+$/',$_POST['geo_maptype'])) {
                $maptype = $_POST['geo_maptype'];
            }
            
            if (isset($_POST['geo_iscustomzoom']) && $_POST['geo_iscustomzoom'] == 1)
                $use_custom_zoom = 1;
            else
                $use_custom_zoom = 0;
			
			$location = Array(
				'address' => $_POST['geo_address'],
				'postcode' => $_POST['geo_postcode'],
				'town' => $_POST['geo_town'],
				'latitude' => $_POST['geo_latitude'],
				'longitude' => $_POST['geo_longitude'],
                'zoom' => $zoom,
                'maptype' => $maptype,
                'use_custom_zoom' => $use_custom_zoom,
			);
			
			 add_post_meta($post_id, FGEORGE_GEOLOCATION, $location);
	
        	if(isset($fg_option['rss_allow_post']) && $fg_option['rss_allow_post']['checked'] == 1) {
				 if (isset($fg_option['feedgeorge_key']) && strlen($fg_option['feedgeorge_key'])>0) {
					$this->send_post($post_id,$location,$fg_option);
				 }
			 }
			 
			 
		}
		
		if($fg_option['isPoly'] == 1 && $_POST['action'] != 'save_poly') {
				if (isset($_POST['fgkml']) && strlen($_POST['fgkml']) > 10) {
					delete_post_meta($post_id, FGEORGE_KMLFILE);
					//add_post_meta($post_id, FGEORGE_KMLFILE, $_POST['fgkml']);
					$point_arr = split(';', $_POST['fgkmldata'][0]);
					
					if (empty($_POST['title'])) $_POST['ptitle'] = $post->post_title;
					
					add_post_meta($post_id, FGEORGE_KMLFILE, array('kml'=>$_POST['fgkml'],'title'=>$_POST['ptitle'],'desc'=>$_POST['pdesc'],'styles'=>$fg_option['heattype_setting'],'points'=>$point_arr));
					$fg_ajax->uploadkmlfile($post_id);
				}
				else if (strlen($_POST['fgkml']) == 0) {
				    delete_post_meta($post_id, FGEORGE_KMLFILE);
					$this->delpost($post_id);
				}
		}
	}
	
	function delpost($post_id) {
		$uploads = wp_upload_dir();
		
		$kmlfile = $uploads['basedir'] . FG_KML_DIR .'/wpfg_'. $post_id .'.kml';
		
		if(file_exists($kmlfile)) {
			unlink($kmlfile);
		}
		
		return true;
	}
	
	
	function send_post($post_id,$location,$arg) {
		$post = get_post($post_id);
		
		if ($post) {
			
			$params = array(
				'entry[title]' => $post->post_title,
				'entry[summary]' => $post->summary,
				'entry[content]' => $post->post_content,
				'entry[lat]' => $location['latitude'], 
				'entry[lng]' => $location['longitude'],
				'entry[subcategory_id]' => $arg[subcat],
				'user' => $arg['rss_allow_post']['user'],
				'pass' => $arg['rss_allow_post']['pass'],
				
			);
			
			$result = $this->send($params,$arg['feedgeorge_key']);
		}
	}
	
	
	function send($params,$key) {
		$apiurl = 'http://api.feedgeorge.com/write_feedgeorge.php';
		
		$poststrings = 'd='.base64_encode(serialize($params)) . '&key=' . $key;
		
		try {
			$ch = curl_init();

			curl_setopt($ch, CURLOPT_URL, $apiurl);
			
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $poststrings);

			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			
			$result = curl_exec($ch);
			curl_close($ch);

			//echo $result;
		}
		catch (Exception $e) {
			//echo 'Caught exception: ',  $e->getMessage(), "\n";
		}
		
		return $result;
	}
	
    function update_config() {
        global $current_blog;
        
        $fgeo_options = Array();
        $front_map = $_POST['front_map'];
        $content_map = $_POST['content_map'];
		
        if(isset($front_map)) {
      
            $fgeo_options['front_map_latitude']  = empty( $front_map['lat'] ) ?  FG_MAP_LAT : $front_map['lat'];
			$fgeo_options['front_map_longitude'] = empty( $front_map['long'] ) ? FG_MAP_LNT : $front_map['long'];
            $fgeo_options['front_map_zoom']      = $_POST['front_map_zoom'];
            
			$fgeo_options['front_map_width']      =  $front_map['width'];
			$fgeo_options['front_map_height']      = $front_map['height'];
        }
        
        
        if (isset($content_map)) {
            $fgeo_options['post_map_latitude']  = empty( $content_map['lat'] ) ?  '3.139003' : $content_map['lat'];
			$fgeo_options['post_map_longitude'] = empty( $content_map['long'] ) ? '101.68685499999992' : $content_map['long'];
            $fgeo_options['post_map_zoom']      = $_POST['content_map_zoom'];
     		$fgeo_options['post_map_width']      =  $content_map['width'];
			$fgeo_options['post_map_height']      = $content_map['height'];
 
        }
        
        if (isset($_POST[fgeo_key]) && preg_match('/^[a-zA-Z0-9]+$/',$_POST[fgeo_key])) {
            $fgeo_options['feedgeorge_key'] = $_POST[fgeo_key];
        }
        
      
		if ($_POST['isallowpost'] == 1) {
			
			if (preg_match('/^[a-z0-9-_]+$/',$_POST[fg_username])) {
				$fgeo_options['rss_allow_post'] = array(
					'checked' => 1,
					'user' => $_POST['fg_username'],
					'pass' => $_POST['fg_passwd'],
					'subcatid' => $_POST['fg_subcatid'],
					);
			}
			
		}
		else {
			unset($fgeo_options['rss_allow_post']);
		}
		
		if ($_POST['fgisHeatmap'] == 1) {
			$fgeo_options['isHeatmap'] = 1;
		}
		
		if ($_POST['fgisPoly'] == 1) {
			$fgeo_options['isPoly'] = 1;
			if(isset($_POST['poly']))
				$fgeo_options['heattype_setting'] = $_POST['poly'];
				
			
			
		}
		
		
		update_option('_FGEORGE_GEOLOCATION_OPTION', $fgeo_options);
        
        echo "Update done";
    }
	
	
	function fgmap_custom_box() {
		global $post;
		$geo_check = '';
		$fgeo_options = get_option("_FGEORGE_GEOLOCATION_OPTION");
		$geolocation = get_post_meta($post->ID, FGEORGE_GEOLOCATION, true);
		
		if ($geolocation) {
			$address = $geolocation[address];
			$postcode = $geolocation[postcode];
			$town = $geolocation[town];
			$latitude = $geolocation['latitude'];
			$longitude = $geolocation['longitude'];
            $mapzoom = $geolocation['zoom'];
            $maptype = $geolocation['maptype'];
            $use_custom_zoom = $geolocation['use_custom_zoom'];
		}
        
        if ($fgeo_options) {
            $fgeo_options = get_option("_FGEORGE_GEOLOCATION_OPTION");
        }
        $post_geomap[latitude] = (empty($fgeo_options['post_map_latitude']))? FG_MAP_LAT : $fgeo_options['post_map_latitude'] ;
        $post_geomap[longitude] = (empty($fgeo_options['post_map_longitude']))? FG_MAP_LNT : $fgeo_options['post_map_longitude']  ;
        $post_geomap[map_zoom] = (empty($fgeo_options['post_map_zoom']))? FG_MAP_ZOOM : $fgeo_options['post_map_zoom'];
        
        if (isset($use_custom_zoom) && $use_custom_zoom==1) {
            $geo_check = 'checked';
        }
        
        $geomapdata = json_encode($post_geomap);
        
        if (isset($geomapdata))
            $geo_option = '<script>var fg_post_map = '.$geomapdata.';</script>';
        
		
		if ($fgeo_options['isPoly'] == 1) {
			$fgkml = get_post_meta($post->ID, FGEORGE_KMLFILE, true);
			
			if (empty($fgkml['title'])) $fgkml['title'] = $post->post_title;
				
			
			$poly = $fgeo_options['heattype_setting'];
			$homeurl = home_url();
			$fgoption = json_encode(Array('home'=>$homeurl,'heattype_opt'=>$fgeo_options['heattype_setting'],'dir'=> FG_REL_URL,'points' => $fgkml['points'])) ;
        }
		
		include_once(FG_THEMES_DIR . '/location_form.php');
	}
	
    
    function show_config_form() {
        global $current_blog;

        $fgeo_options = get_option("_FGEORGE_GEOLOCATION_OPTION");
		
		if (isset($fgeo_options['rss_allow_post']) && $fgeo_options['rss_allow_post']['checked'] == 1) {
			$isallowpost = "checked";
			$fg_username = $fgeo_options['rss_allow_post']['user'];
			$fg_passwd =   $fgeo_options['rss_allow_post']['pass'];
			$fgsubcatid =  $fgeo_options['rss_allow_post']['subcatid'];
		}
        else {
			$fg_username = $fg_passwd = $isallowpost = '';
		}
		
		$poly = array(
			'strokeColor' => "#FF0000",
			'strokeOpacity' => 0.8,
			'strokeWeight' => 2,
			'fillColor' => "#FF0000",
			'fillOpacity' => 0.3,
			'distance' => 500,
		);
		
		if($fgeo_options['isHeatmap'] == 1) { 
			$isheatmap = 'checked';
			
		}
	    
		if($fgeo_options['isPoly'] == 1) { 
			$ispolymap = 'checked';
			
			$poly = $fgeo_options['heattype_setting'];
			
	
		}
		
		$catlistfield = $this->get_category($fgsubcatid);
			
        require_once(FG_THEMES_DIR . '/config_form.php');
    }
    
    function selectMapZoom( $return = 'array', $selected = '',$prefix = 'default' ) {

		// Array
		$map_type_array = array(
			'0' 	=> '0 - ' . 'Zoomed Out', 
			'1' 	=> '1', 
			'2' 	=> '2', 
			'3' 	=> '3', 
			'4' 	=> '4', 
			'5' 	=> '5', 
			'6' 	=> '6', 
			'7' 	=> '7', 
			'8' 	=> '8', 
			'9' 	=> '9', 
			'10' 	=> '10', 
			'11' 	=> '11', 
			'12' 	=> '12', 
			'13' 	=> '13', 
			'14' 	=> '14', 
			'15' 	=> '15', 
			'16' 	=> '16', 
			'17' 	=> '17', 
			'18' 	=> '18', 
			'19' 	=> '19 - ' . 'Zoomed In', 
		);
        
		if ($selected == '') $selected = 12;
        

		if ( $return = 'menu' ) {

            $menu = '';
			foreach ( $map_type_array as $key => $val ) {
				$is_selected = $selected == $key ? ' selected="selected"' : '';
				$menu .= '<option value="' . $key . '"' . $is_selected . '>' . $val . '</option>';
			}

			$menu = '<select name="'. $prefix .'_map_zoom" id="'.$prefix.'_map_zoom">' . $menu. '</select>';
			return $menu;
		}
		// Default return
		return $map_type_array;

	}
	
	function get_op_list($val) {
		$val = sprintf('%.1f',$val);
		
		for($i = 0.0; $i<= 1.0; $i+=0.1) {
			$selected = '';
			if (abs($val-$i)<0.00001) $selected = 'selected';
			
			$out .= sprintf('<option value="%.1f" %s> %.1f </option>',$i,$selected,$i);
		}
		
		return $out;
	}
	
	function get_category($subcatid) {
		global $fgsubcat,$fgcat;
		$catlist = '';
		foreach($fgsubcat as $k => $v) {
			
			$sub = $v[1];
			//echo ucfirst($v[0]).'<br/>';
			foreach($sub as $key1 => $val) {
				if ($key1 == $subcatid) {
					$checked = 'selected';
				}
				else {
					$checked = '';
				}
				
				$catlist .= '<option value="'.$key1.'" '.$checked.' >'.ucfirst($v[0]) . ': '. $val .'</option>';
			}
			
		}
		
		return $catlist;
	}
   
}







?>