<?php
/**
 * FeedGeorge Widget Class
 * 
 * @package FeedGeorge_Wordpress_PLUGIN
 * @author CH Foo
 * @copyright 2011 FeedGeorge.com
 * @access public
 */
 
class feedgeorgeMapWidget extends WP_Widget {
    
    private $got_key = false;
    private $apikey;
    
    /** constructor */
    function feedgeorgeMapWidget() {
        global $fg_geo;
        parent::WP_Widget(false, $name = 'FeedGeorge Nearby');	
        
        $fgeo_options = $fg_geo->get_options();
        
        if (isset($fgeo_options['feedgeorge_key']) && strlen($fgeo_options['feedgeorge_key'])>0) {
            $this->got_key = true;
            $this->apikey = $fgeo_options['feedgeorge_key'];
        }
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {		
        
        if (is_single()) {
			extract( $args );
			$title = apply_filters('widget_title', $instance['title']);
			$height = $instance['height'];
            if (isset($instance['cat'])) 
                $cat = implode(',',$instance['cat']);
        ?>
              <?php echo $before_widget; ?>
                  <?php if ( $title ) echo $before_title . $title . $after_title; ?>
				  <div id="fg_nearbymap" style="width:100%; height:<?php echo $height; ?>px">
				  <?php //_e('Map is Loading... '); ?>
				  </div>
                  <script>var fg_nearcat = '<?php echo $cat ?>';
					jQuery(document).ready( function($){nearbymapWidget.init();});
				  </script>
              <?php echo $after_widget; ?>
        <?php
		}
    }
	
	
	function get_category($arr) {
		global $fgsubcat,$fgcat;
		
		foreach($fgsubcat as $k => $v) {
			
			$sub = $v[1];
			echo ucfirst($v[0]).'<br/>';
			foreach($sub as $key1 => $val) {
				if (is_array($arr) && in_array($key1,$arr)) {
					$checked = 'checked';
				}
				else {
					$checked = '';
				}
				
				echo '<input id="'.$this->get_field_id( 'cat' . $key1 ).'" name="'.$this->get_field_name( 'cat' ).'[]" type="checkbox" value="'.$key1.'" '.$checked.' /><label for="'.$this->get_field_id( 'cat' . $key1 ).'" >'.$val .'</label><br />';
			}
			
		}
	}
	

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
	$instance = $old_instance;
	$instance['title'] = strip_tags($new_instance['title']);
    $instance['height'] = $new_instance['height'];
	$instance['cat'] = $new_instance['cat'];
        return $instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
        $title = esc_attr($instance['title']);
        $height = esc_attr($instance['height']);
		
		if (empty($height)) $height = 300;
		
		if ($title == '') $title = 'Stories Nearby';
		if (!$this->got_key)
            echo '<div class="fg_error_message">
            API Key is missing. The widget will not function without it
            <br/>Please go to "FeedGeorge Setting" and fill in your FeedGeorge API
            </div>
            ';
        ?>
		
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
        <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('Height (px):'); ?> <input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo $height; ?>" /></label></p>
        <p><label for="<?php echo $this->get_field_id('category'); ?>"><?php _e('Category:'); ?><br/><?php $this->get_category($instance['cat']) ?></label> </p>
        <?php 
    }

}

?>